function K2BExtendedSuggestCollection() {
  this.control = null;
  this.Values = null;
  this.selectedValues = [];

  this.SetSelectedValues = function (selectedValues) {
    if (this.control != null) {
      this.control.value = selectedValues;
      this.updateDescription();
    }
    this.selectedValues = selectedValues;
  };

  this.GetSelectedValues = function () {
    return this.selectedValues;
  };

  this.SetValues = function (v) {
    this.Values = v;
    if (this.control != null) {
      this.control.values = this.Values;
    }
  };

  this.updateDescription = function () {
    (async () => {
      await customElements.whenDefined('k2bt-enhancedsuggest');
      const todoListElement = this.control;
      await todoListElement.updateDescription();
    })();
  };

  // In collection controls, the SetValue method sets the value as selected without modifying
  this.SetValue = function (v) {
    if (this.selectedValues.filter(value => v.toString().trim() === value.toString().trim()).length === 0) this.selectedValues.push(v);
    if (this.control != null) this.control.value = this.selectedValues;

    this.onfocus();
    this.oninput();
    this.onchange();

    if (this.ControlValueChanged) {
      this.ControlValueChanged();
    }
  };

  this.show = function () {
    var uc = this;
    if (this.control == null || this.control.length === 0) {
      // Only create control once
      this.control = document.createElement('k2bt-enhancedsuggest');
      this.control.maxSelectionSize = 0;
      this.control.values = this.Values;
      this.control.value = this.selectedValues;

      this.control.addEventListener('SuggestValueChanged', function () {
        uc.SetSelectedValues(uc.control.value);

        uc.oninput();
        uc.onchange();

        if (uc.ControlValueChanged) {
          uc.ControlValueChanged();
        }
      });

      this.control.addEventListener('newRecordClicked', function () {
        if (uc.CreateItem) {
          uc.CreateItem();
        }
      });

      this.control.addEventListener('inputValueChanged', function () {
        uc.Prefix = uc.control.searchvalue;
        if (uc.SeekSuggestValues) {
          uc.SeekSuggestValues();
        }
      });

      this.control.addEventListener('focus', this.onfocus.closure(this));

      var container = document.getElementById(this.ContainerName);
      container.appendChild(this.control);
    }

    this.control.enableadditem = this.EnableAddItem;
    this.control.includeemptyitem = this.IncludeEmptyItem;
    this.control.enabled = this.Enabled;
    this.control.readonlyclass = this.Class.split(' ')
      .map(s => 'Readonly' + s)
      .join(' ');

    this.control.emptyitemtext = k2btools.getTranslatedMessage(k2btools.resolveValue(this.EmptyItemText, 'GX_EmptyItemText'));
    this.control.noresultsfoundtext = k2btools.getTranslatedMessage(k2btools.resolveValue(this.NoResultsFoundText, 'K2BT_NoItems'));
    this.control.additemcaption = k2btools.getTranslatedMessage(k2btools.resolveValue(this.AddItemCaption, 'K2BT_EnhancedComboAddItemCaption'));
    this.control.suggestmaxitems = this.SuggestMaxItems;
  };
}
