var K2BPhoneInput = /** @class */ (function () {
    function K2BPhoneInput(jQuery) {
        this.intlTelInput = null;
        this.preferredCountries = [];
        this.availableCountries = [];
        this.translations = {
            spa: {
                ad: 'Andorra',
                ae: 'Emiratos Árabes Unidos',
                af: 'Afganistán',
                ag: 'Antigua y Barbuda',
                ai: 'Anguila',
                al: 'Albania',
                am: 'Armenia',
                an: 'Antillas Neerlandesas',
                ao: 'Angola',
                aq: 'Antártida',
                ar: 'Argentina',
                as: 'Samoa Americana',
                at: 'Austria',
                au: 'Australia',
                aw: 'Aruba',
                ax: 'Islas Áland',
                az: 'Azerbaiyán',
                ba: 'Bosnia y Herzegovina',
                bb: 'Barbados',
                bd: 'Bangladesh',
                be: 'Bélgica',
                bf: 'Burkina Faso',
                bg: 'Bulgaria',
                bh: 'Bahréin',
                bi: 'Burundi',
                bj: 'Benin',
                bl: 'San Bartolomé',
                bm: 'Bermudas',
                bn: 'Brunéi',
                bo: 'Bolivia',
                br: 'Brasil',
                bs: 'Bahamas',
                bt: 'Bhután',
                bv: 'Isla Bouvet',
                bw: 'Botsuana',
                by: 'Belarús',
                bz: 'Belice',
                ca: 'Canadá',
                cc: 'Islas Cocos',
                cf: 'República Centro-Africana',
                cg: 'Congo',
                ch: 'Suiza',
                ci: 'Costa de Marfil',
                ck: 'Islas Cook',
                cl: 'Chile',
                cm: 'Camerún',
                cn: 'China',
                co: 'Colombia',
                cr: 'Costa Rica',
                cu: 'Cuba',
                cv: 'Cabo Verde',
                cx: 'Islas Christmas',
                cy: 'Chipre',
                cz: 'República Checa',
                de: 'Alemania',
                dj: 'Yibuti',
                dk: 'Dinamarca',
                dm: 'Domínica',
                do: 'República Dominicana',
                dz: 'Argel',
                ec: 'Ecuador',
                ee: 'Estonia',
                eg: 'Egipto',
                eh: 'Sahara Occidental',
                er: 'Eritrea',
                es: 'España',
                et: 'Etiopía',
                fi: 'Finlandia',
                fj: 'Fiji',
                fk: 'Islas Malvinas',
                fm: 'Micronesia',
                fo: 'Islas Faroe',
                fr: 'Francia',
                ga: 'Gabón',
                gb: 'Reino Unido',
                gd: 'Granada',
                ge: 'Georgia',
                gf: 'Guayana Francesa',
                gg: 'Guernsey',
                gh: 'Ghana',
                gi: 'Gibraltar',
                gl: 'Groenlandia',
                gm: 'Gambia',
                gn: 'Guinea',
                gp: 'Guadalupe',
                gq: 'Guinea Ecuatorial',
                gr: 'Grecia',
                gs: 'Georgia del Sur e Islas Sandwich del Sur',
                gt: 'Guatemala',
                gu: 'Guam',
                gw: 'Guinea-Bissau',
                gy: 'Guayana',
                hk: 'Hong Kong',
                hm: 'Islas Heard y McDonald',
                hn: 'Honduras',
                hr: 'Croacia',
                ht: 'Haití',
                hu: 'Hungría',
                id: 'Indonesia',
                ie: 'Irlanda',
                il: 'Israel',
                im: 'Isla de Man',
                in: 'India',
                io: 'Territorio Británico del Océano Índico',
                iq: 'Irak',
                ir: 'Irán',
                is: 'Islandia',
                it: 'Italia',
                je: 'Jersey',
                jm: 'Jamaica',
                jo: 'Jordania',
                jp: 'Japón',
                ke: 'Kenia',
                kg: 'Kirguistán',
                kh: 'Camboya',
                ki: 'Kiribati',
                km: 'Comoros',
                kn: 'San Cristóbal y Nieves',
                kp: 'Corea del Norte',
                kr: 'Corea del Sur',
                kw: 'Kuwait',
                ky: 'Islas Caimán',
                kz: 'Kazajstán',
                la: 'Laos',
                lb: 'Líbano',
                lc: 'Santa Lucía',
                li: 'Liechtenstein',
                lk: 'Sri Lanka',
                lr: 'Liberia',
                ls: 'Lesotho',
                lt: 'Lituania',
                lu: 'Luxemburgo',
                lv: 'Letonia',
                ly: 'Libia',
                ma: 'Marruecos',
                mc: 'Mónaco',
                md: 'Moldova',
                me: 'Montenegro',
                mg: 'Madagascar',
                mh: 'Islas Marshall',
                mk: 'Macedonia',
                ml: 'Mali',
                mm: 'Myanmar',
                mn: 'Mongolia',
                mo: 'Macao',
                mq: 'Martinica',
                mr: 'Mauritania',
                ms: 'Montserrat',
                mt: 'Malta',
                mu: 'Mauricio',
                mv: 'Maldivas',
                mw: 'Malawi',
                mx: 'México',
                my: 'Malasia',
                mz: 'Mozambique',
                na: 'Namibia',
                nc: 'Nueva Caledonia',
                ne: 'Níger',
                nf: 'Islas Norkfolk',
                ng: 'Nigeria',
                ni: 'Nicaragua',
                nl: 'Países Bajos',
                no: 'Noruega',
                np: 'Nepal',
                nr: 'Nauru',
                nu: 'Niue',
                nz: 'Nueva Zelanda',
                om: 'Omán',
                pa: 'Panamá',
                pe: 'Perú',
                pf: 'Polinesia Francesa',
                pg: 'Papúa Nueva Guinea',
                ph: 'Filipinas',
                pk: 'Pakistán',
                pl: 'Polonia',
                pm: 'San Pedro y Miquelón',
                pn: 'Islas Pitcairn',
                pr: 'Puerto Rico',
                ps: 'Palestina',
                pt: 'Portugal',
                pw: 'Islas Palaos',
                py: 'Paraguay',
                qa: 'Qatar',
                re: 'Reunión',
                ro: 'Rumanía',
                rs: 'Serbia y Montenegro',
                ru: 'Rusia',
                rw: 'Ruanda',
                sa: 'Arabia Saudita',
                sb: 'Islas Solomón',
                sc: 'Seychelles',
                sd: 'Sudán',
                se: 'Suecia',
                sg: 'Singapur',
                sh: 'Santa Elena',
                si: 'Eslovenia',
                sj: 'Islas Svalbard y Jan Mayen',
                sk: 'Eslovaquia',
                sl: 'Sierra Leona',
                sm: 'San Marino',
                sn: 'Senegal',
                so: 'Somalia',
                sr: 'Surinam',
                st: 'Santo Tomé y Príncipe',
                sv: 'El Salvador',
                sy: 'Siria',
                sz: 'Suazilandia',
                tc: 'Islas Turcas y Caicos',
                td: 'Chad',
                tf: 'Territorios Australes Franceses',
                tg: 'Togo',
                th: 'Tailandia',
                tj: 'Tayikistán',
                tk: 'Tokelau',
                tl: 'Timor-Leste',
                tm: 'Turkmenistán',
                tn: 'Túnez',
                to: 'Tonga',
                tr: 'Turquía',
                tt: 'Trinidad y Tobago',
                tv: 'Tuvalu',
                tw: 'Taiwán',
                ua: 'Ucrania',
                ug: 'Uganda',
                us: 'Estados Unidos de América',
                uy: 'Uruguay',
                uz: 'Uzbekistán',
                va: 'Ciudad del Vaticano',
                vc: 'San Vicente y las Granadinas',
                ve: 'Venezuela',
                vg: 'Islas Vírgenes Británicas',
                vi: 'Islas Vírgenes de los Estados Unidos de América',
                vn: 'Vietnam',
                vu: 'Vanuatu',
                wf: 'Wallis y Futuna',
                ws: 'Samoa',
                ye: 'Yemen',
                yt: 'Mayotte',
                za: 'Sudáfrica',
            },
            por: {
                af: 'Afeganistão',
                za: 'África do Sul',
                ax: 'Aland, Ilhas',
                al: 'Albânia',
                de: 'Alemanha',
                ad: 'Andorra',
                ao: 'Angola',
                ai: 'Anguila',
                aq: 'Antártida',
                ag: 'Antígua e Barbuda',
                sa: 'Arábia Saudita',
                dz: 'Argélia',
                ar: 'Argentina',
                am: 'Armênia',
                aw: 'Aruba',
                au: 'Austrália',
                at: 'Áustria',
                az: 'Azerbaijão',
                bs: 'Bahamas',
                bd: 'Bangladexe',
                bb: 'Barbados',
                bh: 'Barém',
                be: 'Bélgica',
                bz: 'Belize',
                bj: 'Benim',
                bm: 'Bermudas',
                by: 'Bielorrússia',
                bo: 'Bolívia',
                bq: 'Bonaire, Santo Eustáquio e Saba',
                ba: 'Bósnia e Herzegovina',
                bw: 'Botsuana',
                bv: 'Bouvet, Ilha',
                br: 'Brasil',
                bn: 'Brunei',
                bg: 'Bulgária',
                bf: 'Burquina Fasso',
                bi: 'Burundi',
                bt: 'Butão',
                cv: 'Cabo Verde',
                ky: 'Caimã, Ilhas',
                kh: 'Camboja',
                cm: 'Camarões',
                ca: 'Canadá',
                qa: 'Catar',
                kz: 'Cazaquistão',
                cf: 'Centro-Africana, República',
                td: 'Chade',
                cz: 'Chéquia',
                cl: 'Chile',
                cn: 'China',
                cy: 'Chipre',
                cc: 'Cocos, Ilhas',
                co: 'Colômbia',
                km: 'Comores',
                cg: 'Congo, República do',
                cd: 'Congo, República Democrática do (antigo Zaire)',
                ck: 'Cook, Ilhas',
                kr: 'Coreia do Sul',
                kp: 'Coreia, República Democrática da (Coreia do Norte)',
                ci: 'Costa do Marfim',
                cr: 'Costa Rica',
                hr: 'Croácia',
                cu: 'Cuba',
                cw: 'Curaçau',
                dk: 'Dinamarca',
                dj: 'Djibuti',
                dm: 'Dominica',
                do: 'Dominicana, República',
                eg: 'Egito',
                sv: 'El Salvador',
                ae: 'Emirados Árabes Unidos',
                ec: 'Equador',
                er: 'Eritreia',
                sk: 'Eslováquia',
                si: 'Eslovênia',
                es: 'Espanha',
                us: 'Estados Unidos',
                ee: 'Estónia',
                sz: 'Essuatíni',
                sj: 'Esvalbarde e Jan Mayen',
                et: 'Etiópia',
                fo: 'Feroé, Ilhas',
                fj: 'Fiji',
                ph: 'Filipinas',
                fi: 'Finlândia',
                fr: 'França',
                ga: 'Gabão',
                gm: 'Gâmbia',
                gh: 'Gana',
                ge: 'Geórgia',
                gs: 'Geórgia do Sul e Sanduíche do Sul, Ilhas',
                gi: 'Gibraltar',
                gd: 'Granada',
                gr: 'Grécia',
                gl: 'Groenlândia',
                gp: 'Guadalupe',
                gu: 'Guam',
                gt: 'Guatemala',
                gg: 'Guernsey',
                gy: 'Guiana',
                gf: 'Guiana Francesa',
                gw: 'Guiné-Bissau',
                gn: 'Guiné-Conacri',
                gq: 'Guiné Equatorial',
                ht: 'Haiti',
                hm: 'Heard e Ilhas McDonald, Ilha',
                hn: 'Honduras',
                hk: 'Hong Kong',
                hu: 'Hungria',
                ye: 'Iémen',
                in: 'Índia',
                id: 'Indonésia',
                iq: 'Iraque',
                ir: 'Irã',
                ie: 'Irlanda',
                is: 'Islândia',
                il: 'Israel',
                it: 'Itália',
                jm: 'Jamaica',
                jp: 'Japão',
                je: 'Jersey',
                jo: 'Jordânia',
                kw: 'Kuwait',
                la: 'Laos',
                ls: 'Lesoto',
                lv: 'Letônia',
                lb: 'Líbano',
                lr: 'Libéria',
                ly: 'Líbia',
                li: 'Listenstaine',
                lt: 'Lituânia',
                lu: 'Luxemburgo',
                mo: 'Macau',
                mk: 'Macedônia do Norte',
                mg: 'Madagáscar',
                yt: 'Maiote',
                my: 'Malásia',
                mw: 'Maláui',
                mv: 'Maldivas',
                ml: 'Mali',
                mt: 'Malta',
                fk: 'Malvinas, Ilhas (Falkland)',
                im: 'Man, Ilha de',
                mp: 'Marianas Setentrionais',
                ma: 'Marrocos',
                mh: 'Marshall, Ilhas',
                mq: 'Martinica',
                mu: 'Maurícia',
                mr: 'Mauritânia',
                um: 'Menores Distantes dos Estados Unidos, Ilhas',
                mx: 'México',
                mm: 'Mianmar (antiga Birmânia)',
                fm: 'Micronésia, Estados Federados da',
                mz: 'Moçambique',
                md: 'Moldávia',
                mc: 'Mônaco',
                mn: 'Mongólia',
                ms: 'Monserrate',
                me: 'Montenegro',
                na: 'Namíbia',
                cx: 'Natal, Ilha do (Ilha Christmas)',
                nr: 'Nauru',
                np: 'Nepal',
                ni: 'Nicarágua',
                ne: 'Níger',
                ng: 'Nigéria',
                nu: 'Niue',
                nf: 'Norfolque, Ilha',
                no: 'Noruega',
                nc: 'Nova Caledônia',
                nz: 'Nova Zelândia (Aotearoa)',
                om: 'Omã',
                nl: 'Países Baixos (Holanda)',
                pw: 'Palau',
                ps: 'Palestina',
                pa: 'Panamá',
                pg: 'Papua-Nova Guiné',
                pk: 'Paquistão',
                py: 'Paraguai',
                pe: 'Peru',
                pn: 'Pitcairn',
                pf: 'Polinésia Francesa',
                pl: 'Polônia',
                pr: 'Porto Rico',
                pt: 'Portugal',
                ke: 'Quênia',
                kg: 'Quirguistão',
                ki: 'Quiribáti',
                gb: 'Reino Unido da Grã-Bretanha e Irlanda do Norte',
                re: 'Reunião',
                ro: 'Romênia',
                rw: 'Ruanda',
                ru: 'Rússia',
                eh: 'Saara Ocidental',
                as: 'Samoa Americana',
                ws: 'Samoa (Samoa Ocidental)',
                sb: 'Salomão, Ilhas',
                sm: 'San Marino',
                sh: 'Santa Helena',
                lc: 'Santa Lúcia',
                bl: 'São Bartolomeu',
                kn: 'São Cristóvão e Neves',
                mf: 'São Martinho (França)',
                sx: 'São Martinho (Países Baixos)',
                pm: 'São Pedro e Miquelão',
                st: 'São Tomé e Príncipe',
                vc: 'São Vicente e Granadinas',
                sc: 'Seicheles',
                sn: 'Senegal',
                lk: 'Seri Lanca',
                sl: 'Serra Leoa',
                rs: 'Sérvia',
                sg: 'Singapura',
                sy: 'Síria',
                so: 'Somália',
                sd: 'Sudão',
                ss: 'Sudão do Sul',
                se: 'Suécia',
                ch: 'Suíça',
                sr: 'Suriname',
                th: 'Tailândia',
                tw: 'Taiwan',
                tj: 'Tajiquistão',
                tz: 'Tanzânia',
                tf: 'Terras Austrais e Antárticas Francesas (TAAF)',
                io: 'Território Britânico do Oceano Índico',
                tl: 'Timor-Leste',
                tg: 'Togo',
                to: 'Tonga',
                tk: 'Toquelau',
                tt: 'Trindade e Tobago',
                tn: 'Tunísia',
                tc: 'Turcas e Caicos',
                tm: 'Turcomenistão',
                tr: 'Turquia',
                tv: 'Tuvalu',
                ua: 'Ucrânia',
                ug: 'Uganda',
                uy: 'Uruguai',
                uz: 'Usbequistão',
                vu: 'Vanuatu',
                va: 'Vaticano',
                ve: 'Venezuela',
                vn: 'Vietnã',
                vi: 'Virgens Americanas, Ilhas',
                vg: 'Virgens Britânicas, Ilhas',
                wf: 'Wallis e Futuna',
                zm: 'Zâmbia',
                zw: 'Zimbábue',
            },
        };
        this.$ = jQuery;
    }
    K2BPhoneInput.prototype.SetAttribute = function (data) {
        this.attribute = data;
        if (this.intlTelInput) {
            this.intlTelInput.setNumber(data);
            this.refreshControl();
        }
    };
    K2BPhoneInput.prototype.GetAttribute = function () {
        return this.attribute;
    };
    K2BPhoneInput.prototype.SetDefaultCountry = function (countryCode) {
        this.countryCode = countryCode;
        if (this.intlTelInput)
            this.intlTelInput.setCountry(this.countryCode);
    };
    K2BPhoneInput.prototype.SetPreferredCountries = function (countries) {
        this.preferredCountries = countries;
        if (this.input)
            this.refreshControl();
    };
    K2BPhoneInput.prototype.SetAvailableCountries = function (countries) {
        this.availableCountries = countries;
        if (this.input)
            this.refreshControl();
    };
    K2BPhoneInput.prototype.show = function () {
        try {
            if (!this.input) {
                this.container = document.getElementById(this.ContainerName);
                if (!this.input) {
                    this.input = document.createElement('INPUT');
                    this.input.className = this.Class + ' form-control';
                    this.container.appendChild(this.input);
                    this.refreshControl();
                    this.input.addEventListener('change', this.processChange.bind(this));
                    this.input.addEventListener('countrychange', this.processChange.bind(this));
                    this.input.addEventListener('input', function () {
                        this.updateIsValidFlag();
                        if (this.oninput)
                            this.oninput();
                    }.bind(this));
                }
            }
            if (!this.Enabled) {
                this.input.disabled = true;
                this.container.classList.add('K2BT_PhoneInputDisabled');
            }
            else {
                this.input.disabled = false;
                this.container.classList.remove('K2BT_PhoneInputDisabled');
            }
        }
        catch (e) {
            console.log(e);
        }
    };
    K2BPhoneInput.prototype.refreshControl = function () {
        //@ts-ignore
        var translations = this.translations[gx.languageCode] ? this.translations[gx.languageCode] : {};
        //@ts-ignore
        this.intlTelInput = window.intlTelInput(this.input, {
            placeholderNumberType: this.PlaceholderNumberType,
            nationalMode: this.NationalMode,
            localizedCountries: translations,
            onlyCountries: this.availableCountries,
            preferredCountries: this.preferredCountries,
            //@ts-ignore
            utilsScript: '/' + gx.basePath + gx.staticDirectory + 'K2BPhoneInput/lib/js/utils.js?1678446285328',
        });
        if (this.countryCode)
            this.intlTelInput.setCountry(this.countryCode);
        if (this.attribute)
            this.intlTelInput.setNumber(this.attribute);
    };
    K2BPhoneInput.prototype.processChange = function () {
        this.updateIsValidFlag();
        this.InternationalNumber = this.intlTelInput.getNumber();
        this.NationalNumber = this.input.value;
        this.attribute = this.InternationalNumber;
        //@ts-ignore
        if (this.onchange)
            this.onchange();
        if (this.ControlValueChanged)
            this.ControlValueChanged();
    };
    K2BPhoneInput.prototype.updateIsValidFlag = function () {
        this.ContainsValidNumber = this.intlTelInput.isValidNumber();
        this.ValidationError = this.intlTelInput.getValidationError();
    };
    return K2BPhoneInput;
}());
